
%global meadversion 23.0.2.0_1
%global namedversion 23.0.2.0-1-redhat-00001
%global meadalpha .redhat_00001
%global meadrel .1
%global serial 1
%global namedversionrel redhat-00001

# Template marker
%bcond_without mead

# Mandrel is sensitive to internal changes of the JDK so we need to make sure
# Mandrel is compatible with the installed JDK, thus we require a specific
# jdk version to be installed.
%global jdkversion %(rpm -q --qf '%%{VERSION}-%%{RELEASE}' java-17-openjdk || : )
%global jdkepoch %(rpm -q --qf '%%{EPOCH}:' java-17-openjdk || : )
# Please don't add architecture specific bits to this global. See the post
# script where this is being used.
%global jdkdir %{_jvmdir}/java-17-openjdk-%{jdkversion}

%define maven_version 23.0.2.0-1-redhat-00001

Name:    quarkus-mandrel-java
Summary: Mandrel jars
Version: %{meadversion}
Release: %{serial}%{meadalpha}%{meadrel}%{?dist}
License: GPLv2 with exceptions
Group:   Development/Java

%if %with mead
Source102: mandrel-packaging-wrapper-linux-amd64-23.0.2.0-1-redhat-00001.pom
Source103: graal-sdk-23.0.2.0-1-redhat-00001-sources.jar
Source104: jvmti-agent-base-23.0.2.0-1-redhat-00001.jar
Source105: svm-driver-23.0.2.0-1-redhat-00001.pom
Source106: svm-23.0.2.0-1-redhat-00001.jar
Source107: native-image-base-23.0.2.0-1-redhat-00001-sources.jar
Source108: svm-diagnostics-agent-23.0.2.0-1-redhat-00001.jar
Source109: svm-configure-23.0.2.0-1-redhat-00001-sources.jar
Source110: compiler-23.0.2.0-1-redhat-00001-sources.jar
Source111: compiler-23.0.2.0-1-redhat-00001.pom
Source112: svm-diagnostics-agent-23.0.2.0-1-redhat-00001.pom
Source113: jvmti-agent-base-23.0.2.0-1-redhat-00001-sources.jar
Source114: objectfile-23.0.2.0-1-redhat-00001.jar
Source115: svm-configure-23.0.2.0-1-redhat-00001.pom
Source116: mandrel-java-all-23.0.2.0-1-redhat-00001-project-sources.tar.gz
Source117: mandrel-packaging-wrapper-linux-amd64-23.0.2.0-1-redhat-00001.jar
Source118: objectfile-23.0.2.0-1-redhat-00001-sources.jar
Source119: library-support-23.0.2.0-1-redhat-00001.pom
Source120: svm-diagnostics-agent-23.0.2.0-1-redhat-00001-sources.jar
Source121: svm-23.0.2.0-1-redhat-00001-sources.jar
Source122: objectfile-23.0.2.0-1-redhat-00001.pom
Source123: svm-agent-23.0.2.0-1-redhat-00001-sources.jar
Source124: svm-configure-23.0.2.0-1-redhat-00001.jar
Source125: library-support-23.0.2.0-1-redhat-00001-sources.jar
Source126: svm-agent-23.0.2.0-1-redhat-00001.pom
Source127: compiler-23.0.2.0-1-redhat-00001.jar
Source128: pointsto-23.0.2.0-1-redhat-00001.jar
Source129: pointsto-23.0.2.0-1-redhat-00001.pom
Source130: svm-agent-23.0.2.0-1-redhat-00001.jar
Source131: graal-sdk-23.0.2.0-1-redhat-00001.pom
Source132: pointsto-23.0.2.0-1-redhat-00001-sources.jar
Source133: svm-driver-23.0.2.0-1-redhat-00001-sources.jar
Source134: svm-driver-23.0.2.0-1-redhat-00001.jar
Source135: native-image-base-23.0.2.0-1-redhat-00001.jar
Source136: native-image-base-23.0.2.0-1-redhat-00001.pom
Source137: svm-23.0.2.0-1-redhat-00001.pom
Source138: library-support-23.0.2.0-1-redhat-00001.jar
Source139: jvmti-agent-base-23.0.2.0-1-redhat-00001.pom
Source140: graal-sdk-23.0.2.0-1-redhat-00001.jar
%endif


URL:     https://github.com/graalvm/mandrel

BuildArch: noarch
BuildRequires: javapackages-filesystem
BuildRequires: java-17-openjdk-devel

%description
%{summary}.

%package jdk-17-binding
Summary: Mandrel jars for JDK 17 based build
Requires: java-17-openjdk-devel = %{jdkepoch}%{jdkversion}
Requires: %{name} = %{version}

%description jdk-17-binding
%{summary}.

%prep
if [ -z "%jdkversion" ]
then
    echo "rpm failed to obtain java-17-openjdk version, check BuildRequires"
    exit 11
fi

%build

%install
cd %{_sourcedir}
# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}

for jar in *-%{namedversion}*.jar; do %{__cp} -p ${jar} %{buildroot}%{_javadir}/%{name}/${jar/-%{namedversion}/}; done

# symlinks from foo.src.zip to foo-sources.jar
%{__ln_s} %{_javadir}/%{name}/library-support-sources.jar %{buildroot}%{_javadir}/%{name}/library-support.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-sources.jar %{buildroot}%{_javadir}/%{name}/svm.src.zip
%{__ln_s} %{_javadir}/%{name}/pointsto-sources.jar %{buildroot}%{_javadir}/%{name}/pointsto.src.zip
%{__ln_s} %{_javadir}/%{name}/objectfile-sources.jar %{buildroot}%{_javadir}/%{name}/objectfile.src.zip
%{__ln_s} %{_javadir}/%{name}/native-image-base-sources.jar %{buildroot}%{_javadir}/%{name}/native-image-base.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-driver-sources.jar %{buildroot}%{_javadir}/%{name}/svm-driver.src.zip
%{__ln_s} %{_javadir}/%{name}/jvmti-agent-base-sources.jar %{buildroot}%{_javadir}/%{name}/jvmti-agent-base.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-agent-sources.jar %{buildroot}%{_javadir}/%{name}/svm-agent.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-diagnostics-agent-sources.jar %{buildroot}%{_javadir}/%{name}/svm-diagnostics-agent.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-configure-sources.jar %{buildroot}%{_javadir}/%{name}/svm-configure.src.zip
%{__ln_s} %{_javadir}/%{name}/graal-sdk-sources.jar %{buildroot}%{_javadir}/%{name}/graal-sdk.src.zip
%{__ln_s} %{_javadir}/%{name}/compiler-sources.jar %{buildroot}%{_javadir}/%{name}/graal.src.zip

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/svm.jar
%{_javadir}/%{name}/svm-sources.jar
%{_javadir}/%{name}/svm.src.zip
%{_javadir}/%{name}/pointsto.jar
%{_javadir}/%{name}/pointsto-sources.jar
%{_javadir}/%{name}/pointsto.src.zip
%{_javadir}/%{name}/objectfile.jar
%{_javadir}/%{name}/objectfile-sources.jar
%{_javadir}/%{name}/objectfile.src.zip
%{_javadir}/%{name}/native-image-base.jar
%{_javadir}/%{name}/native-image-base-sources.jar
%{_javadir}/%{name}/native-image-base.src.zip
%{_javadir}/%{name}/svm-driver.jar
%{_javadir}/%{name}/svm-driver-sources.jar
%{_javadir}/%{name}/svm-driver.src.zip
%{_javadir}/%{name}/graal-sdk.jar
%{_javadir}/%{name}/graal-sdk-sources.jar
%{_javadir}/%{name}/graal-sdk.src.zip
%{_javadir}/%{name}/compiler.jar
%{_javadir}/%{name}/compiler-sources.jar
%{_javadir}/%{name}/graal.src.zip
%{_javadir}/%{name}/library-support.jar
%{_javadir}/%{name}/library-support-sources.jar
%{_javadir}/%{name}/library-support.src.zip
%{_javadir}/%{name}/jvmti-agent-base.jar
%{_javadir}/%{name}/jvmti-agent-base-sources.jar
%{_javadir}/%{name}/jvmti-agent-base.src.zip
%{_javadir}/%{name}/svm-agent.jar
%{_javadir}/%{name}/svm-agent-sources.jar
%{_javadir}/%{name}/svm-agent.src.zip
%{_javadir}/%{name}/svm-diagnostics-agent.jar
%{_javadir}/%{name}/svm-diagnostics-agent-sources.jar
%{_javadir}/%{name}/svm-diagnostics-agent.src.zip
%{_javadir}/%{name}/svm-configure.jar
%{_javadir}/%{name}/svm-configure-sources.jar
%{_javadir}/%{name}/svm-configure.src.zip
%{_javadir}/%{name}/mandrel-packaging-wrapper-linux-amd64.jar

%files jdk-17-binding
# No files, just for pulling in the version-specific JDK

%post
# Add symlinks in OpenJDK. This must not use macros which
# contain arch-full paths. Macros get expanded at build time
# and this is a noarch package, while the JDK install includes
# the achitecture in the path. The trick here is to use 'uname -m'
# for the architecture bits which is correct since the script
# runs on the target arch at install time and not at build time.
JDK_DIR="%{jdkdir}.$(uname -m)"
%{__mkdir_p} ${JDK_DIR}/lib/svm
%{__ln_s} %{_javadir}/%{name}/library-support.jar ${JDK_DIR}/lib/svm/
%{__ln_s} %{_javadir}/%{name}/library-support.src.zip ${JDK_DIR}/lib/svm/

%{__mkdir_p} ${JDK_DIR}/lib/svm/builder
%{__ln_s} %{_javadir}/%{name}/svm.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/svm.src.zip ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/pointsto.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/pointsto.src.zip ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/objectfile.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/objectfile.src.zip ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/native-image-base.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/native-image-base.src.zip ${JDK_DIR}/lib/svm/builder/

%{__mkdir_p} ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-driver.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-driver.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/jvmti-agent-base.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/jvmti-agent-base.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-agent.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-agent.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-diagnostics-agent.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-diagnostics-agent.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-configure.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-configure.src.zip ${JDK_DIR}/lib/graalvm

%{__mkdir_p} ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/graal-sdk.jar ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/graal-sdk.src.zip ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/compiler.jar ${JDK_DIR}/lib/jvmci/graal.jar
%{__ln_s} %{_javadir}/%{name}/graal.src.zip ${JDK_DIR}/lib/jvmci/

%postun
# Remove mandrel symlinks in OpenJDK install location
JDK_DIR="%{jdkdir}.$(uname -m)"
if [ -e "${JDK_DIR}/lib/svm" ]; then
%{__rm} -rf ${JDK_DIR}/lib/svm
fi
if [ -e "${JDK_DIR}/lib/jvmci" ]; then
%{__rm} -rf ${JDK_DIR}/lib/jvmci
fi
if [ -e "${JDK_DIR}/lib/graalvm" ]; then
%{__rm} -rf ${JDK_DIR}/lib/graalvm
fi


%changelog
* Wed Oct 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.2.0_1-1.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Oct 17 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-8.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Oct 17 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-7.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Oct 17 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-6.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Oct 16 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-5.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Oct 16 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-4.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Jul 26 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-3.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jul 25 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-2.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jul 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.1.0_1-1.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jul 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-10.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 17 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-9.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jul 14 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-8.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jul 14 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-7.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jul 14 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-6.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jul 14 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-5.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Jul 13 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-4.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Jul 13 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-3.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-2.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 23.0.0.0_2-1.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 10 2023 Severin Gehwolf <sgehwolf@redhat.com> - 23.0.0.0-1
- Initial wrapper RPM package for Mandrel 23
